Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter bool : Type.
Parameter true : bool.
Parameter false : bool.
Axiom match_bool_prop : forall (return_:(bool -> Prop)), (return_ true) -> (return_ false) -> forall (z:bool), return_ z.
Parameter match_bool_type : forall (return_:Type), return_ -> return_ -> bool -> return_.
Axiom axiom_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), connectives.equal (return_) (match_bool_type (return_) case_true case_false true) case_true.
Definition eq_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) (match_bool_type (return_) case_true case_false true) case_true := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((connectives.equal_leibniz) (return_)) (match_bool_type (return_) case_true case_false true)) (case_true)) ((((axiom_match_bool_type_true) (return_)) (case_true)) (case_false)).
Axiom axiom_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), connectives.equal (return_) (match_bool_type (return_) case_true case_false false) case_false.
Definition eq_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) (match_bool_type (return_) case_true case_false false) case_false := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((connectives.equal_leibniz) (return_)) (match_bool_type (return_) case_true case_false false)) (case_false)) ((((axiom_match_bool_type_false) (return_)) (case_true)) (case_false)).
Definition sym_eq_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) case_true (match_bool_type (return_) case_true case_false true) := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((leibniz.sym_leibniz) (return_)) (match_bool_type (return_) case_true case_false true)) (case_true)) ((((eq_match_bool_type_true) (return_)) (case_true)) (case_false)).
Definition sym_eq_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) case_false (match_bool_type (return_) case_true case_false false) := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((leibniz.sym_leibniz) (return_)) (match_bool_type (return_) case_true case_false false)) (case_false)) ((((eq_match_bool_type_false) (return_)) (case_true)) (case_false)).
Definition andb : bool -> bool -> bool := fun (b1:bool) => fun (b2:bool) => match_bool_type (bool) b2 false b1.
Definition andb_true_r : forall (b1:bool), forall (b2:bool), (logic.eq (bool) (andb b1 b2) true) -> logic.eq (bool) b2 true := fun (b1:bool) => fun (b2:bool) => ((((match_bool_prop) (fun (__:bool) => (logic.eq (bool) (andb __ b2) true) -> logic.eq (bool) b2 true)) ((((((sym_eq_match_bool_type_true) (bool)) (b2)) (false)) (fun (x:bool) => (logic.eq (bool) x true) -> logic.eq (bool) b2 true)) (fun (auto:logic.eq (bool) b2 true) => (((((((logic.rewrite_l) (bool)) (b2)) (fun (__:bool) => logic.eq (bool) b2 __)) (((logic.refl) (bool)) (b2))) (true)) (auto))))) ((((((sym_eq_match_bool_type_false) (bool)) (b2)) (false)) (fun (x:bool) => (logic.eq (bool) x true) -> logic.eq (bool) b2 true)) (((((match_bool_prop) (fun (__:bool) => (logic.eq (bool) false true) -> logic.eq (bool) __ true)) (fun (auto:logic.eq (bool) false true) => (((logic.refl) (bool)) (true)))) (fun (auto:logic.eq (bool) false true) => (((((((logic.rewrite_r) (bool)) (true)) (fun (__:bool) => logic.eq (bool) __ true)) (((logic.refl) (bool)) (true))) (false)) (auto)))) (b2)))) (b1).
